widget_vincentdjango/assignments/urls.py
from django.urls import path
from .views import homeAssignmentsPage, AssignmentsDetailView, AssignmentsUpdateView, AssignmentsCreateView

urlpatterns = [
    path('', homeAssignmentsPage, name='homePage'),
    path('add/', AssignmentsCreateView.as_view(), name='assignment_add'),
    path('<int:pk>/details/', AssignmentsDetailView.as_view(), name='assignment_details'),
    path('<int:pk>/edit/', AssignmentsUpdateView.as_view(), name='assignment_update'),
]

app_name = "assignments"

widget_vincentdjango/forum/urls.py
# forum/urls.py
from django.urls import path

from .views import index, ForumPostDetailView, ForumPostCreateView, ForumPostUpdateView

urlpatterns = [
    path('', index, name='index'),
    path('forumposts/<int:pk>/details', ForumPostDetailView.as_view(), name='forumpost-details'),
    path('forumposts/add', ForumPostCreateView.as_view(), name='forumpost-add'),
    path('forumposts/<int:pk>/edit', ForumPostUpdateView.as_view(), name='forumpost-edit'),
]

# This might be needed, depending on your Django version
app_name = "forum"

widget_vincentdjango/widget_vincentdjango/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('dashboard.urls', namespace="dashboard")),
    path('calendar/', include('widget_calendar.urls', namespace="widget_calendar")),
    path('assignments/', include('assignments.urls', namespace="assignments")),
    path('announcements/', include('announcements.urls', namespace="announcements")),
    path('forum/', include('forum.urls', namespace="forum")),
]

widget_vincentdjango/forum/models.py
# forum/models.py
from django.db import models
from dashboard.models import WidgetUser
from django.urls import reverse
from datetime import datetime

class ForumPost(models.Model):
    title = models.CharField(max_length=100)
    body = models.CharField(max_length=200)
    author = models.ForeignKey(
        WidgetUser,
        null=True,
        default=True,
        on_delete=models.CASCADE,
    )
    pub_datetime = models.DateTimeField(
        default=datetime.now(),
        editable=False,
    )

    def __str__(self):
        return self.title

    def format_pub_datetime(self):
        return self.pub_datetime.strftime('%m/%d/%Y %I:%M %p')

    def get_absolute_url(self):
        return reverse('forum:forumpost-details', kwargs={'pk': self.pk})


class Reply(models.Model):
    post = models.ForeignKey(
        ForumPost,
        null=True,
        default=True,
        on_delete=models.CASCADE,
        related_name="replies",
    )
    body = models.CharField(max_length=200)
    author = models.ForeignKey(
        WidgetUser,
        null=True,
        default=True,
        on_delete=models.CASCADE,
    )
    pub_datetime = models.DateTimeField()

    def __str__(self):
        return self.body

    def format_pub_datetime(self):
        return self.pub_datetime.strftime('%m/%d/%Y %I:%M %p')
    

widget_vincentdjango/forum/views.py
from django.shortcuts import render
from django.http import HttpResponse
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView, UpdateView

from dashboard.models import WidgetUser
from .models import ForumPost, Reply


def index(request):
    forumposts = ForumPost.objects.all()
    replies = Reply.objects.all()
    return render(request, 'forum/forum.html', {'forumposts': forumposts, 'replies': replies})

class ForumPostDetailView(DetailView):
    model = ForumPost
    template_name = 'forum/forumpost-details.html'

class ForumPostCreateView(CreateView):
    model = ForumPost
    template_name = 'forum/forumpost-add.html'
    fields = ["title", "body", "author"]

class ForumPostUpdateView(UpdateView):
    model = ForumPost
    template_name = 'forum/forumpost-edit.html'
    fields = '__all__'

widget_vincentdjango/forum/templates/forum/forum.html
{% extends 'base.html' %}
{% load static %}

{% block title %} Widget's Forum {% endblock %}
{% block heading %}
	<h1 id="header"> Welcome to Widget's Forum! </h1>
	<div class="separator-bar"></div>
{% endblock %}
{% block content %}
	<h2 class="subheader"> Forum Posts: </h2>
	<ul>
		{% for forumpost in forumposts|dictsortreversed:"pub_datetime" %}
		<li class="object-cell">
			<a href="{{ forumpost.get_absolute_url }}"> <span class="object-title">{{ forumpost.title }}</span> <span class="object-subtitle">by {{ forumpost.author.first_name }} {{ forumpost.author.last_name }}</span> </a>
		</li>
		{% endfor %}
    </ul>
	<div class="separator-bar"></div>
{% endblock %}
{% block navigation %}
	<button onclick="window.location.href='{% url 'forum:forumpost-add' %}';" class="action-button"> New Post </button>
    <div id="footer">
        <a href="{% url 'dashboard:index' %}">Dashboard</a>
        <a href="{% url 'announcements:index' %}">Announcements</a>
        <a href="{% url 'assignments:homePage' %}">Assignments</a>
        <a href="{% url 'widget_calendar:index' %}">Calendar</a>
    </div>
{% endblock %}

widget_vincentdjango/forum/templates/forum/forumpost-add.html
{% extends 'base.html' %}
{% load static %}

{% block title %} Add Post {% endblock %}
{% block heading %}
	<h1 class="subheader"> Add a new Post: </h1>
{% endblock %}
{% block content %}
	<form method="post">
		{% csrf_token %}
		<div class="form-fields"> {{ form.as_p }} </div>
		<div class="separator-bar"></div>
		<input class="action-button" type="submit" value="Save New Post">
	</form>
{% endblock %}

widget_vincentdjango/forum/templates/forum/forumpost-details.html
{% extends 'base.html' %}
{% load static %}

{% block title %} {{ object.title }} {% endblock %}
{% block heading %}
	<h1 class="detail-header"> {{ object.title }} </h1>
	<h2 class="detail-additionalinfo"> by {{ object.author.first_name }} {{ object.author.last_name }} </h2>
	<h4 class="detail-additionalinfo"> {{ object.format_pub_datetime }} </h4>
	<p class="detail-body"> {{ object.body }} </p>
{% endblock %}
{% block content %}
	<div class="separator-bar"></div>
	<h2 class="subheader"> Post Replies: </h2>
	{% for reply in object.replies.all %}
		<p class="detail-additionalinfo"> by {{ reply.author.first_name }} {{ reply.author.last_name }} </p>
		<p class="detail-additionalinfo"> {{ reply.format_pub_datetime }} </p>
		<p class="detail-body"> {{ reply.body }} </p>
		<br>
	{% endfor %}
	<div class="separator-bar"></div>
	<button class="action-button" onclick="window.location.href='{% url 'forum:forumpost-edit' pk=object.pk %}';"> Edit Post </button>
{% endblock %}

widget_vincentdjango/forum/templates/forum/forumpost-edit.html
{% extends 'base.html' %}
{% load static %}

{% block title %} Edit Post {% endblock %}
{% block heading %}
	<h1 class="subheader"> Edit Post: </h1>
{% endblock %}
{% block content %}
	<form method="post">
		{% csrf_token %}
		{{ form.as_p }}
		<div class="separator-bar"></div>
		<input type="submit" value="Save Changes" class="action-button">
	</form>
{% endblock %}